=begin
  Copyright 2009/2010 (c), TIG
  All Rights Reserved.
  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
  WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###
     #extrusionToolbar.rb
###
Function:
  Makes a Toolbar called 'Extrusion Toolbar' IF one of anumber of 
  extrudeEdges.. scripts are available...  
        
Donations:
  Are welcome [by PayPal], please use 'TIGdonations.htm' in the 
  ../Plugins/TIGtools/ folder.
        
Version:
  1.0 20100114 First release.
  1.1 20100215 EEbyFaces and EEbyRailsbyFaces added.
  1.2 20100216 All extrusion-tools now in one in Plugins sub-menu.
=end
###
require 'sketchup.rb'
require 'deBabelizer.rb'
###
class ExtrusionToolbar

def db(string)
  dir=File.dirname(__FILE__)+"/TIGtools"
  toolname="#extrusionToolbar"
  locale=Sketchup.get_locale.upcase
  path=dir+"/"+toolname+locale+".lingvo"
  if not File.exist?(path)
    return string
  else
    deBabelizer(string,path)
  end 
end#def
  
def initialize
  eePlugins=["extrudeEdgesByVector","extrudeEdgesByLathe","extrudeEdgesByRails","extrudeEdgesByEdges","extrudeEdgesByFace","extrudeEdgesByFaces","extrudeEdgesByRailsByFace","Manifold"]
  gotPlugin=false
  eePlugins.each{|plugin|
    if Sketchup.find_support_file(plugin+".rb","Plugins/")
      gotPlugin=true
      break
    end#if
  }
  if gotPlugin ### we've got at least ONE plugin...
    $extrusionToolbar=UI::Toolbar.new(db"Extrusion Tools")
    $extrusionToolbar.restore if $extrusionToolbar.get_last_state==TB_VISIBLE
    $extrusionToolsSubmenu = UI.menu("Plugins").add_submenu((db"Extrusion Tools")+"...")
  else
    $extrusionToolbar=nil
    $extrusionToolsSubmenu=nil
    return nil
  end#if
end#def

end#class
###
ExtrusionToolbar.new
###
