=begin
#-----------------------------------------------------------------------
Copyright 2009 TIG: Permission to use, copy, modify, and distribute 
this software for any purpose and without fee is hereby granted, 
provided this notice appears in any copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
Adds faces that are 'missing' from selected edges.
If selection includes face[s] then tries to orient new faces.
If no selected faces then it tries to orient so not 'inside out'.
It's not foolproof...
Be aware that it might make internal faces you don't expect...
You can call it from other scripts by making a selection-set then...
  addfaces()
To run manually make a selection and type 'addfaces' in the ruby console
(without the surrounding '')
It has no menu entry by default - to add one remove the 
'###' in front of the menu lines in the end section...
#-----------------------------------------------------------------------
Version:	1.0	20090327	First Issue
#-----------------------------------------------------------------------
=end
require 'sketchup.rb'
def addfaces()
  model=Sketchup.active_model
  selection=model.selection
  model.start_operation("AddFaces")
  edges=[]
  faces1=[]
  selection.each{|e|
    edges.push(e)if e.typename=="Edge" and e.faces.length<2
    faces1.push(e)if e.typename=="Face"
  }
  faces1.uniq!
  faces=[]
edges.length.times do |facer|
  edges.each{|e|
    e.find_faces
    e.faces.each{|f|faces.push(f)}
  }
end#do
  # repeats to catch any remainders - new faceless edges now with a face
  faces.uniq!
  faces=faces - faces1
  # now try to orient all faces...
  if not faces1[0] and faces[0]
    faces[0].reverse!
    # this tries to ensure not 'inside out'
  end#if
# do multiple orient to double check...
(faces.length).times do |orient|
   awaiting_faces=(faces1+faces)
  (faces1+faces).each{|face1|
    edgs=face1.edges
    edgs.each{|edg|
      rev1=edg.reversed_in?(face1)
      common_faces=edg.faces-[face1]
      common_faces.each{|face2|
	      rev2=edg.reversed_in?(face2)
        face2.reverse! if awaiting_faces.include?(face2) and rev1==rev2
	      awaiting_faces=awaiting_faces-[face2]
      }
    }
  }
end#do
  selection.clear
  faces.each{|e|
    selection.add(e)
    selection.add(e.edges)
  }
  model.commit_operation
  return faces.length
end#def
### #Optional Plugin Menu - remove all starting ### to enable menu(s)
###if(not file_loaded?("addfaces.rb"))###for TIG menus only
###   UI.menu("Plugins").add_item("Add Faces [to Selected Edges]"){addfaces()}
###   ### #Optional Context Menu
###   UI.add_context_menu_handler do |menu|
###      selection=Sketchup.active_model.selection
###      if selection[0]# only shows if edge selected
###        gotEdge=false;selection.each{|e|gotEdge=true if e.typename=="Edge"}
###        menu.add_item("Add Faces [to Selected Edges]"){addfaces()}if gotEdge
###      end#if
###   end#do
###end
###file_loaded("addfaces.rb")
### #EOF
