require "sketchup.rb"
require "extensions.rb"

$uStrings = LanguageHandler.new("cd_architect")
cd_architect_Extension = SketchupExtension.new $uStrings.GetString("cd_architect"), "cd_architect.rb"
cd_architect_Extension.description=$uStrings.GetString("Architect")
cd_architect_Extension.name= "cd_architect"

Sketchup.register_extension cd_architect_Extension, true

# Run
def exec_on_autoload
  puts("cd_architect loaded.")
end

if( not $cd_architect_menu_loaded )

  #tweak Toolbar


  _cd_architect_plugins_menu = UI.menu("Plugins").add_submenu("SCF 建筑工具")

  gp_cd_architect_tb = UI::Toolbar.new("SCF 建筑工具")






  #################################   MENUS    #####################################



cmd = UI::Command.new("Simplify Contours") { simplyContours }
  cmd.small_icon = "CD_ICONS/ARCHITECT/simplify_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/simplify_24.png"
  cmd.tooltip = "简化等高线"
  cmd.status_bar_text = "简化等高线"
  cmd.menu_text = "Simplify Contours"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("简化等高线") { simplyContours }


  ##################################################################################################




cmd = UI::Command.new("Make Contours") { Contours.calculate }
  cmd.small_icon = "CD_ICONS/ARCHITECT/MakeContours_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/MakeContours_24.png"
  cmd.tooltip = "建立等高线"
  cmd.status_bar_text = "建立等高线"
  cmd.menu_text = "建立等高线"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("建立等高线") { Contours.calculate }


  ##################################################################################################



cmd = UI::Command.new("Triangulate points") { triangulate_points }
  cmd.small_icon = "CD_ICONS/ARCHITECT/Triangulatepoints_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/Triangulatepoints_24.png"
  cmd.tooltip = "点分三角面"
  cmd.status_bar_text = "点分三角面"
  cmd.menu_text = "点分三角面"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("点分三角面") { triangulate_points }


  ##################################################################################################

cmd = UI::Command.new("Pointify") { Pointify.start }
  cmd.small_icon = "CD_ICONS/ARCHITECT/Pointify_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/Pointify_24.png"
  cmd.tooltip = "点编辑"
  cmd.status_bar_text = "点编辑"
  cmd.menu_text = "点编辑"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("点编辑") { Pointify.start }


  ##################################################################################################
#cmd = UI::Command.new("Convex Hull") { Qhull.mesh }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/ConvexHull_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/ConvexHull_24.png"
  #cmd.tooltip = "光滑蒙皮"
  #cmd.status_bar_text = "光滑蒙皮"
  #cmd.menu_text = "光滑蒙皮"
  #	gp_cd_architect_tb.add_item(cmd)

  #       _cd_architect_plugins_menu.add_item("光滑蒙皮") { Qhull.mesh }


  ##################################################################################################
  #cmd = UI::Command.new("Voronoi") { Qvoronoi.mesh }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/Voronoi_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/Voronoi_24.png"
  #cmd.tooltip = "Voronoi"
  #cmd.status_bar_text = "Voronoi"
  #cmd.menu_text = "Voronoi"
  #	gp_cd_architect_tb.add_item(cmd)

  #       _cd_architect_plugins_menu.add_item("Voronoi") { Qvoronoi.mesh }


  ##################################################################################################
  #cmd = UI::Command.new("Export CPoints") { Qexport.write }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/ExportCPoints_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/ExportCPoints_24.png"
  #cmd.tooltip = "Export CPoints"
  #cmd.status_bar_text = "Export CPoints"
  #cmd.menu_text = "Export CPoints"
  #	gp_cd_architect_tb.add_item(cmd)

  #       _cd_architect_plugins_menu.add_item("Export CPoints") { Qexport.write }




  ##################################################################################################
cmd = UI::Command.new("Terrain Reshaper") { trn_terrain }
  cmd.small_icon = "CD_ICONS/ARCHITECT/TerrainReshaper_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/TerrainReshaper_24.png"
  cmd.tooltip = "重新生成地形"
  cmd.status_bar_text = "重新生成地形"
  cmd.menu_text = "重新生成地形"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("重新生成地形") { trn_terrain }


  ##################################################################################################





  gp_cd_architect_tb.add_separator








  ##################################################################################################




cmd = UI::Command.new("Hipped Roof [From Selected Face]"){Roof::hip}
  cmd.small_icon = "CD_ICONS/ARCHITECT/roofhipped_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/roofhipped_24.png"
  cmd.tooltip = "四坡屋顶[从选择面建立]"
  cmd.status_bar_text = "四坡屋顶[从选择面建立]"
  cmd.menu_text = "四坡屋顶[从选择面建立]"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("四坡屋顶[从选择面建立]"){Roof::hip}


  ##################################################################################################




cmd = UI::Command.new("Mansard | Sprocket Roof [From Selected Face]"){Roof::mansard}
  cmd.small_icon = "CD_ICONS/ARCHITECT/roofmansard_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/roofmansard_24.png"
  cmd.tooltip = "曲尺屋顶[从选择面建立]"
  cmd.status_bar_text = "曲尺屋顶[从选择面建立]"
  cmd.menu_text = "曲尺屋顶[从选择面建立]"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("曲尺屋顶[从选择面建立]"){Roof::mansard}


  ##################################################################################################



cmd = UI::Command.new("Gable-Ended Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofGable.new}
  cmd.small_icon = "CD_ICONS/ARCHITECT/roofgable_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/roofgable_24.png"
  cmd.tooltip = "山墙屋顶[三点建立]"
  cmd.status_bar_text = "山墙屋顶[三点建立]"
  cmd.menu_text = "山墙屋顶[三点建立]"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("山墙屋顶[三点建立]"){Sketchup.active_model.select_tool RoofGable.new}


  ##################################################################################################



cmd = UI::Command.new("Pyramid Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofPyramid.new}
  cmd.small_icon = "CD_ICONS/ARCHITECT/roofPyramid_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/roofPyramid_24.png"
  cmd.tooltip = "锥形屋顶[三点建立]"
  cmd.status_bar_text = "锥形屋顶[三点建立]"
  cmd.menu_text = "锥形屋顶[三点建立]"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("锥形屋顶[三点建立]"){Sketchup.active_model.select_tool RoofPyramid.new}


  ##################################################################################################



cmd = UI::Command.new("Get Slope [From Selected Face]"){Roof::get_slope}
  cmd.small_icon = "CD_ICONS/ARCHITECT/roofslope_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/roofslope_24.png"
  cmd.tooltip = "坡道[从选择面建立]"
  cmd.status_bar_text = "坡道[从选择面建立]"
  cmd.menu_text = "坡道[从选择面建立]"
  #	gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("坡道[从选择面建立]"){Roof::get_slope}


##################################################################################################


  gp_cd_architect_tb.add_separator



#cmd = UI::Command.new("Straight Stair") { stairconc }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/stairStraight_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/stairStraight_24.png"
  #cmd.tooltip = "直跑楼梯"
  #cmd.status_bar_text = "直跑楼梯"
  #cmd.menu_text = "直跑楼梯"
  #	gp_cd_architect_tb.add_item(cmd)

  #       _cd_architect_plugins_menu.add_item("直跑楼梯") { stairconc }


  ##################################################################################################





  ##################################################################################################



cmd = UI::Command.new("Create Stair") { create_stair }
  cmd.small_icon = "CD_ICONS/ARCHITECT/stair_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/stair_24.png"
  cmd.tooltip = "创建楼梯"
  cmd.status_bar_text = "创建楼梯"
  cmd.menu_text = "创建楼梯"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("创建楼梯") { create_stair }

  ##################################################################################################



cmd = UI::Command.new("Scissor Stair") { stairconcu }
  cmd.small_icon = "CD_ICONS/ARCHITECT/stairScissor_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/stairScissor_24.png"
  cmd.tooltip = "剪形楼梯"
  cmd.status_bar_text = "剪形楼梯"
  cmd.menu_text = "剪形楼梯"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("剪形楼梯") { stairconcu }


  ##################################################################################################



cmd = UI::Command.new("90º Left") { stairconcl }
  cmd.small_icon = "CD_ICONS/ARCHITECT/stair90left_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/stair90left_24.png"
  cmd.tooltip = "双跑楼梯"
  cmd.status_bar_text = "双跑楼梯"
  cmd.menu_text = "90� Left"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("双跑楼梯") { stairconcl }
  ##################################################################################################



cmd = UI::Command.new("Spiral Stairs") { spiral_stair }
  cmd.small_icon = "CD_ICONS/ARCHITECT/stairSpiral_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/stairSpiral_24.png"
  cmd.tooltip = "螺旋楼梯"
  cmd.status_bar_text = "螺旋楼梯"
  cmd.menu_text = "螺旋楼梯"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("螺旋楼梯") { spiral_stair }



  ##################################################################################################



cmd = UI::Command.new("Create Windows") { Window.create }
  cmd.small_icon = "CD_ICONS/ARCHITECT/windows_16.png"
  cmd.large_icon = "CD_ICONS/ARCHITECT/windows_24.png"
  cmd.tooltip = "建立窗"
  cmd.status_bar_text = "建立窗"
  cmd.menu_text = "建立窗"
  gp_cd_architect_tb.add_item(cmd)

  _cd_architect_plugins_menu.add_item("建立窗") { Window.create }


  ##################################################################################################



#cmd = UI::Command.new("Glass") { Sketchup.active_model.select_tool WindowTools::GlassTool.new }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/wglass.png_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/wglass.png_24.png"
  #cmd.status_bar_text = "玻璃工具"
  #cmd.tooltip = "玻璃工具"
  #	gp_cd_architect_tb.add_item(cmd)

  #cmd = UI::Command.new("Frame") { Sketchup.active_model.select_tool WindowTools::FrameTool.new }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/wframe_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/wframe_24.png"
  #cmd.status_bar_text = "Frame Tool"
  #cmd.tooltip = "Frame Tool"
  #	gp_cd_architect_tb.add_item(cmd)

  #cmd = UI::Command.new("Trim") { Sketchup.active_model.select_tool WindowTools::TrimTool.new }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/wtrim_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/wtrim_24.png"
  #cmd.status_bar_text = "Trim Tool"
  #cmd.tooltip = "Trim Tool"
  #	gp_cd_architect_tb.add_item(cmd)

  #cmd = UI::Command.new("Mullions") { Sketchup.active_model.select_tool WindowTools::MullionTool.new }
  #cmd.small_icon = "CD_ICONS/ARCHITECT/wmullion_16.png"
  #cmd.large_icon = "CD_ICONS/ARCHITECT/wmullion_24.png"
  #cmd.status_bar_text = "Mullion Tool"
  #cmd.tooltip = "Mullion Tool"
  #	gp_cd_architect_tb.add_item(cmd)




































  $cd_architect_menu_loaded = true
end
file_loaded("cd_architect.rb")
