require "sketchup.rb"
require "extensions.rb"

$uStrings = LanguageHandler.new("cd_draw_m")
cd_draw_m_Extension = SketchupExtension.new $uStrings.GetString("cd_draw_m"), "cd_draw_m.rb"
cd_draw_m_Extension.description=$uStrings.GetString("Ruby tweaktools.")
cd_draw_m_Extension.name= "cd_draw_m"

Sketchup.register_extension cd_draw_m_Extension, true

# Run
def exec_on_autoload
  puts("cd_draw_m loaded.")
end

if( not $cd_draw_m_menu_loaded )


  ##############################################################################################
  _cd_draw_m_plugins_menu = UI.menu("Plugins").add_submenu("SCF 绘图工具")
  ##############################################################################################
  gp_cd_draw_m_tb = UI::Toolbar.new("SCF 绘图工具")
  ##############################################################################################

  ##################################################   MENUS    ################################

  ##############################################################################################

cmd3 = UI::Command.new(("Construction Points")) { Sketchup.active_model.select_tool AddCpointTool.new }
  cmd3.small_icon = "CD_ICONS/DRAW/constructionpoint_16.png"
  cmd3.large_icon = "CD_ICONS/DRAW/constructionpoint_24.png"
  cmd3.tooltip = "辅助点"
  gp_cd_draw_m_tb.add_item(cmd3)

  ##############################################################################################

cmd12 = UI::Command.new("3 Point Grid") { Sketchup.active_model.select_tool GridTool.new }
  cmd12.small_icon = "CD_ICONS/DRAW/grid3points_16.png"
  cmd12.large_icon = "CD_ICONS/DRAW/grid3points_24.png"
  cmd12.tooltip = "3点网格编辑"
  gp_cd_draw_m_tb.add_item(cmd12)

  ##############################################################################################

cmd10 = UI::Command.new(("Rotated Rectangle")) { Sketchup.active_model.select_tool RectangleTool.new }
  cmd10.small_icon = "CD_ICONS/DRAW/rotatedrectangle_16.png"
  cmd10.large_icon = "CD_ICONS/DRAW/rotatedrectangle_24.png"
  cmd10.tooltip = "自由矩形"
  gp_cd_draw_m_tb.add_item(cmd10)
  _cd_draw_m_plugins_menu.add_item(("自由矩形")) { Sketchup.active_model.select_tool RectangleTool.new }

  ##############################################################################################

cmd = UI::Command.new("Ellipse") { Ellipse.tool }
  cmd.small_icon = "CD_ICONS/DRAW/ellipse_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/ellipse_24.png"
  cmd.tooltip = "椭圆"
  cmd.status_bar_text = "椭圆"
  cmd.menu_text = "椭圆"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("椭圆") { Ellipse.tool }

  ##############################################################################################

cmd = UI::Command.new("Arc: 3 Points") { Arc3pts.tool }
  cmd.small_icon = "CD_ICONS/DRAW/arc3p_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/arc3p_24.png"
  cmd.tooltip = "3点定圆弧"
  cmd.status_bar_text = "3点定圆弧"
  cmd.menu_text = "3点定圆弧"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("3点定圆弧") { Arc3pts.tool }

  ##############################################################################################

cmd = UI::Command.new("Arc: Center and 2 points") { Arccenter.tool }
  cmd.small_icon = "CD_ICONS/DRAW/arc3pb_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/arc3pb_24.png"
  cmd.tooltip = "圆心及2端点定圆弧"
  cmd.status_bar_text = "圆心及2端点定圆弧"
  cmd.menu_text = "圆心及2端点定圆弧"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("圆心及2端点定圆弧") { Arccenter.tool }

  ##################################################################################################

cmd = UI::Command.new("Draw Helix") { drawhelix }
  cmd.small_icon = "CD_ICONS/DRAW/helix_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/helix_24.png"
  cmd.tooltip = "螺旋线"
  cmd.status_bar_text = "螺旋线"
  cmd.menu_text = "螺旋线"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("螺旋线") { drawhelix }

  ##################################################################################################

cmd = UI::Command.new("Double line") { dline }
  cmd.small_icon = "CD_ICONS/DRAW/doubleline_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/doubleline_24.png"
  cmd.tooltip = "双线"
  cmd.status_bar_text = "双线"
  cmd.menu_text = "双线"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("双线") { dline }

  ##################################################################################################
  gp_cd_draw_m_tb.add_separator
  _cd_draw_m_plugins_menu.add_separator
  ##################################################################################################

  #   3D SHAPES TOOL
cmd = UI::Command.new("Rotated Pyramid")  {Sketchup.active_model.select_tool PyramidTool.new }
  cmd.small_icon = "CD_ICONS/DRAW/rot_pyramid_icon_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/rot_pyramid_icon_24.png"
  cmd.tooltip = "方椎体"
  cmd.status_bar_text = "方椎体"
  cmd.menu_text = "方椎体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("方椎体")  {Sketchup.active_model.select_tool PyramidTool.new }

  ##############################################################################################

cmd = UI::Command.new("Cone or Pyramid")  {Sketchup.active_model.select_tool ConeTool.new  }
  cmd.small_icon = "CD_ICONS/DRAW/cone_icon_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/cone_icon_24.png"
  cmd.tooltip = "圆锥体"
  cmd.menu_text = "圆锥体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("圆锥体")  {Sketchup.active_model.select_tool ConeTool.new  }

  ##############################################################################################

cmd = UI::Command.new("Sphere")  {Sketchup.active_model.select_tool SphereTool.new  }
  cmd.small_icon = "CD_ICONS/DRAW/sphere_icon_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/sphere_icon_24.png"
  cmd.tooltip = "球体"
  cmd.menu_text = "球体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("球体")  {Sketchup.active_model.select_tool SphereTool.new  }

  ##############################################################################################
  _cd_draw_m_plugins_menu.add_separator
  ##################################################################################################

cmd = UI::Command.new("Box") { Box.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawbox_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawbox_24.png"
  cmd.tooltip = "六面体"
  cmd.status_bar_text = "六面体"
  cmd.menu_text = "六面体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("六面体") { Box.new }

  ##################################################################################################

cmd = UI::Command.new("Cylinder") { Cylinder.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawCylinder_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawCylinder_24.png"
  cmd.tooltip = "圆柱体"
  cmd.status_bar_text = "圆柱体"
  cmd.menu_text = "圆柱体"
  #gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("圆柱体") { Cylinder.new }

  ##################################################################################################

cmd = UI::Command.new("Cone") { Cone.new }
  #cmd.small_icon = "CD_ICONS/DRAW/drawCone_16.png"
  #cmd.large_icon = "CD_ICONS/DRAW/drawCone_24.png"
  #cmd.tooltip = "椎体"
  #cmd.status_bar_text = "椎体"
  #cmd.menu_text = "椎体"
  #gp_cd_draw_m_tb.add_item(cmd)
  #_cd_draw_m_plugins_menu.add_item("椎体") { Cone.new }

  ##################################################################################################

cmd = UI::Command.new("Torus") { Torus.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawTorus_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawTorus_24.png"
  cmd.tooltip = "圆环"
  cmd.status_bar_text = "圆环"
  cmd.menu_text = "圆环"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("圆环") { Torus.new }

  ##################################################################################################
cmd = UI::Command.new("Tube") { Tube.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawTube_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawTube_24.png"
  cmd.tooltip = "圆管"
  cmd.status_bar_text = "圆管"
  cmd.menu_text = "Tube"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("圆管") { Tube.new }

  ##################################################################################################

cmd = UI::Command.new("Dome") { Dome.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawDome_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawDome_24.png"
  cmd.tooltip = "半球"
  cmd.status_bar_text = "半球"
  cmd.menu_text = "半球"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("半球") { Dome.new }

##################################################################################################

cmd = UI::Command.new("Prism") { Prism.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawPrism_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawPrism_24.png"
  cmd.tooltip = "棱柱体"
  cmd.status_bar_text = "棱柱体"
  cmd.menu_text = "棱柱体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("棱柱体") { Prism.new }

  ##################################################################################################

cmd = UI::Command.new("Pyramid") { Pyramid.new }
  cmd.small_icon = "CD_ICONS/DRAW/drawPyramid_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/drawPyramid_24.png"
  cmd.tooltip = "棱锥体"
  cmd.status_bar_text = "棱锥体"
  cmd.menu_text = "棱锥体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("棱锥体") { Pyramid.new }

##############################################################################################

cmd = UI::Command.new("Icosahedron")  {Sketchup.active_model.select_tool IcosahedronTool.new }
 cmd.small_icon = "CD_ICONS/DRAW/icosahedron_icon_16.png"
 cmd.large_icon = "CD_ICONS/DRAW/icosahedron_icon_24.png"
 cmd.tooltip = "二十面体"
 cmd.status_bar_text = "二十面体"
 cmd.menu_text = "二十面体"
 gp_cd_draw_m_tb.add_item(cmd)
 _cd_draw_m_plugins_menu.add_item("二十面体")  {Sketchup.active_model.select_tool IcosahedronTool.new }

  ##############################################################################################

cmd = UI::Command.new("Dodecahedron")  {Sketchup.active_model.select_tool DodecahedronTool.new }
  cmd.small_icon = "CD_ICONS/DRAW/dodecahedron_icon_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/dodecahedron_icon_24.png"
  cmd.tooltip = "十二面体"
  cmd.status_bar_text = "十二面体"
  cmd.menu_text = "十二面体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("十二面体")  {Sketchup.active_model.select_tool DodecahedronTool.new }

  ##############################################################################################

cmd = UI::Command.new("Superellipse/Superellipsoid") { superellipse_superellipsoid }
 cmd.small_icon = "CD_ICONS/DRAW/Superellipse_16.png"
 cmd.large_icon = "CD_ICONS/DRAW/Superellipse_24.png"
 cmd.tooltip = "超级椭圆"
 cmd.status_bar_text = "超级椭圆"
 cmd.menu_text = "超级椭圆"
 gp_cd_draw_m_tb.add_item(cmd)
 _cd_draw_m_plugins_menu.add_item("超级椭圆") { superellipse_superellipsoid }

  ##################################################################################################
  _cd_draw_m_plugins_menu.add_separator
  ##################################################################################################


cmd = UI::Command.new("Tear Drop") { tear_drop }      
  cmd.small_icon = "CD_ICONS/DRAW/TearDrop_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/TearDrop_24.png"
  cmd.tooltip = "雨滴"
  cmd.status_bar_text = "雨滴"
  cmd.menu_text = "雨滴"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("雨滴") { tear_drop }

  ##################################################################################################

cmd = UI::Command.new("Horn Shape") { horn_shape }    
  cmd.small_icon = "CD_ICONS/DRAW/horn_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/horn_24.png"
  cmd.tooltip = "号角"
  cmd.status_bar_text = "号角"
  cmd.menu_text = "号角"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("号角") { horn_shape }

  ##################################################################################################

cmd = UI::Command.new("Misc Torus") { misc_torus }  
  cmd.small_icon = "CD_ICONS/DRAW/toruses_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/toruses_24.png"
  cmd.tooltip = "花托"
  cmd.status_bar_text = "花托"
  cmd.menu_text = "花托"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("花托") { misc_torus }

  ##################################################################################################

cmd = UI::Command.new("Jet Surface") { jet_surface }
  cmd.small_icon = "CD_ICONS/DRAW/jetsurface_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/jetsurface_24.png"
  cmd.tooltip = "流线型"
  cmd.status_bar_text = "流线型"
  cmd.menu_text = "流线型"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("流线型") { jet_surface }

  ##################################################################################################

cmd = UI::Command.new("Pisot Triaxial") { pisot_triaxial }
  cmd.small_icon = "CD_ICONS/DRAW/pisot_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/pisot_24.png"
  cmd.tooltip = "麦比乌斯圈"
  cmd.status_bar_text = "麦比乌斯圈"
  cmd.menu_text = "麦比乌斯圈"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("麦比乌斯圈") { pisot_triaxial }

  ##################################################################################################

cmd = UI::Command.new("Elliptic Torus") { elliptic_torus }
 cmd.small_icon = "CD_ICONS/DRAW/torus2_16.png"
 cmd.large_icon = "CD_ICONS/DRAW/torus2_24.png"
 cmd.tooltip = "椭圆形花托"
 cmd.status_bar_text = "椭圆形花托"
 cmd.menu_text = "椭圆形花托"
 gp_cd_draw_m_tb.add_item(cmd)
 _cd_draw_m_plugins_menu.add_item("椭圆形花托") { elliptic_torus }

  ##################################################################################################

cmd = UI::Command.new("Limpet Torus") { limpet_torus }
  cmd.small_icon = "CD_ICONS/DRAW/limpet_16.png"
  cmd.large_icon = "CD_ICONS/DRAW/limpet_24.png"
  cmd.tooltip = "帽型体"
  cmd.status_bar_text = "帽型体"
  cmd.menu_text = "帽型体"
  gp_cd_draw_m_tb.add_item(cmd)
  _cd_draw_m_plugins_menu.add_item("帽型体") { limpet_torus }

  ##################################################################################################

  $cd_draw_m_menu_loaded = true
end
file_loaded("cd_draw_m.rb")
