require "sketchup.rb"
require "extensions.rb"

$uStrings = LanguageHandler.new("cd_power_m")
cd_power_m_Extension = SketchupExtension.new $uStrings.GetString("cd_power_m"), "cd_power_m.rb"
cd_power_n_Extension = SketchupExtension.new $uStrings.GetString("cd_power_n"), "cd_power_n.rb"
cd_power_m_Extension.description=$uStrings.GetString("Power Toolbar")
cd_power_n_Extension.description=$uStrings.GetString("Power Toolbar")
cd_power_m_Extension.name= "cd_power_m"
cd_power_n_Extension.name= "cd_power_n"


Sketchup.register_extension cd_power_m_Extension, true

def exec_on_autoload
  puts("cd_power_m loaded.")
  puts("cd_power_n loaded.")
end



##############################################################################################
_cd_power_m_plugins_menu = UI.menu("Plugins").add_submenu("SCF POWERBAR")
_freeform_menu =_cd_power_m_plugins_menu.add_submenu("FREEFORM")
_utilities_menu =_cd_power_m_plugins_menu.add_submenu("UTILITIES")
##############################################################################################
gp_cd_power_m_tb = UI::Toolbar.new("SCF POWERBAR")
##############################################################################################
   

   
   
   
####################################################   MENUS    #######################################



##################################################################################################  
   
cmd1 = UI::Command.new("Extrude Along Path (TIG)") {  extrude_along_path  }
cmd1.small_icon = "CD_ICONS/POWER/extrudealongpath_16.png"
cmd1.large_icon = "CD_ICONS/POWER/extrudealongpath_24.png"
cmd1.tooltip = "Extrude Rectangular Face Along a Selected Path"
gp_cd_power_m_tb.add_item(cmd1)
_utilities_menu.add_item("Extrude Along Path  TIG)") {  extrude_along_path  }
      
##################################################################################################  

cmd2 = UI::Command.new("Pipe Along Path (TIG) (SAVE BEFORE USE)") { pipe_along_path }
cmd2.small_icon = "CD_ICONS/POWER/pipealongpath_16.png"
cmd2.large_icon = "CD_ICONS/POWER/pipealongpath_24.png"
cmd2.tooltip = "Makes Pipes Along Selected Path"
gp_cd_power_m_tb.add_item(cmd2)
_utilities_menu.add_item("Pipe Along Path (TIG) (SAVE BEFORE USE)") { pipe_along_path }

##################################################################################################  

cmd3 = UI::Command.new("Copy to Path Nodes (TIG)") { Sketchup.active_model.select_tool PathCopy.new }
cmd3.small_icon = "CD_ICONS/POWER/copytopathnodes_16.png"
cmd3.large_icon = "CD_ICONS/POWER/copytopathnodes_24.png"
cmd3.tooltip = "Copy Array Groups or Components Along Path Nodes"
gp_cd_power_m_tb.add_item(cmd3)
_utilities_menu.add_item("Copy to path nodes (TIG)") { Sketchup.active_model.select_tool PathCopy.new }

##################################################################################################  

cmd4 = UI::Command.new("Copy to Spacing (TIG)") { Sketchup.active_model.select_tool PathCopySpacing.new }      
cmd4.small_icon = "CD_ICONS/POWER/copytospacing_16.png"
cmd4.large_icon = "CD_ICONS/POWER/copytospacing_24.png"
cmd4.tooltip = "Copy Array Groups or Components Along the Path by Distance"
gp_cd_power_m_tb.add_item(cmd4)
_utilities_menu.add_item("Copy to spacing (TIG)") { Sketchup.active_model.select_tool PathCopySpacing.new }      

##################################################################################################  	  
gp_cd_power_m_tb.add_separator
##################################################################################################  

cmd5 = UI::Command.new("Mirror Selection (TIG) (SAVE BEFORE USE)") { Sketchup.active_model.select_tool MirrorTool.new }
cmd5.small_icon = "CD_ICONS/POWER/mirror_16.png"
cmd5.large_icon = "CD_ICONS/POWER/mirror_24.png"
cmd5.tooltip = "Mirror Objects in 2D or 3D mode - (Save File Before Use)"
gp_cd_power_m_tb.add_item(cmd5)
_cd_power_m_plugins_menu.add_item("Mirror Selection (TIG) (SAVE BEFORE USE)") { Sketchup.active_model.select_tool MirrorTool.new }
 
##################################################################################################  

fn = File.basename(__FILE__, ".rb")
fn = "Mover2"
p fn
unless file_loaded?("#{fn}.rb")
cmd20 = UI::Command.new(fn.capitalize) {
begin
Mover2.new(fn)
rescue => e
s = "#{e}"
body = e.backtrace.join("\n")
end
}
cmd20.small_icon = "CD_ICONS/POWER/mover2_16.png"
cmd20.large_icon = "CD_ICONS/POWER/mover2_24.png"
cmd20.tooltip = "Move, Rotate and Copy Groups or Components by Set Distances (Jim Foltz)"
gp_cd_power_m_tb.add_item(cmd20)
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
_cd_power_m_plugins_menu.add_item(fn.capitalize) {
begin
Mover2.new(fn)
rescue => e
s = "#{e}"
body = e.backtrace.join("\n")
UI.openURL("mailto:jim.foltz@gmail.com&subject=#{s}&body=#{body}")
end
}
file_loaded "#{fn}.rb"
end
  
##################################################################################################
gp_cd_power_m_tb.add_separator
_cd_power_m_plugins_menu.add_separator   
##################################################################################################  

cmd8 = UI::Command.new("Drop at intersection (TBD)") { Drop.drop_intersection } # if Drop.validate_drop_entity
cmd8.small_icon = "CD_ICONS/POWER/dropintersection_16.png"
cmd8.large_icon = "CD_ICONS/POWER/dropintersection_24.png"
cmd8.tooltip = "Drop Group/Component to Nearest Intersection on Z"
gp_cd_power_m_tb.add_item(cmd8)
_cd_power_m_plugins_menu.add_item("Drop at intersection (TBD)") { Drop.drop_intersection } # if Drop.validate_drop_entity

cmd9 = UI::Command.new("Drop at ... (TBD)") { Drop.drop_at } # if Drop.validate_drop_entity
cmd9.small_icon = "CD_ICONS/POWER/dropatlevel_16.png"
cmd9.large_icon = "CD_ICONS/POWER/dropatlevel_24.png"
cmd9.tooltip = "Drop Group/Component On Selected Level (Change In Z)"
gp_cd_power_m_tb.add_item(cmd9)
_cd_power_m_plugins_menu.add_item("Drop at ... (TBD)") { Drop.drop_at } # if Drop.validate_drop_entity

##################################################################################################
gp_cd_power_m_tb.add_separator  
_cd_power_m_plugins_menu.add_separator  
################################################################################################## 

cmd12 = UI::Command.new(("Push-Pull faces along their normals (Didier Bur)")) { (extrude_faces_along_normal) }
cmd12.small_icon = "CD_ICONS/POWER/projectfacenormal_16.png"
cmd12.large_icon = "CD_ICONS/POWER/projectfacenormal_24.png"
cmd12.tooltip = "Push-Pull Multiple Faces Along Their Normals"
gp_cd_power_m_tb.add_item(cmd12)
_cd_power_m_plugins_menu.add_item(("Push-Pull faces along their normals (Didier Bur)")) { (extrude_faces_along_normal) }

################################################################################################## 

cmd13 = UI::Command.new(("Push-Pull faces randomly (Didier Bur)")) { (randomPushPull) }
cmd13.small_icon = "CD_ICONS/POWER/projectfacerandom_16.png"
cmd13.large_icon = "CD_ICONS/POWER/projectfacerandom_24.png"
cmd13.tooltip = "Pushpull faces Randomly Within a Distance"
gp_cd_power_m_tb.add_item(cmd13)
_cd_power_m_plugins_menu.add_item(("Push-Pull faces randomly (Didier Bur)")) { (randomPushPull) }

################################################################################################## 

cmd14 = UI::Command.new(("Push-Pull faces along vector (Didier Bur)")) { Sketchup.active_model.select_tool PushPullFacesVectorTool.new }
cmd14.small_icon = "CD_ICONS/POWER/projectfacevector_16.png"
cmd14.large_icon = "CD_ICONS/POWER/projectfacevector_24.png"
cmd14.tooltip = "Pushpull Faces Along a Vector"
gp_cd_power_m_tb.add_item(cmd14)
_cd_power_m_plugins_menu.add_item(("Push-Pull faces along vector (Didier Bur)")) { Sketchup.active_model.select_tool PushPullFacesVectorTool.new }

##################################################################################################  

cmd6 = UI::Command.new("Extrude lines (Didier Bur)") { ex_linetool }
cmd6.small_icon = "CD_ICONS/POWER/extrudelines_16.png"
cmd6.large_icon = "CD_ICONS/POWER/extrudelines_24.png"
cmd6.tooltip = "Extrude Lines Along a Vector"
gp_cd_power_m_tb.add_item(cmd6)
_cd_power_m_plugins_menu.add_item("Extrude lines (Didier Bur)") { ex_linetool }

################################################################################################## 
gp_cd_power_m_tb.add_separator
_cd_power_m_plugins_menu.add_separator   
################################################################################################## 

cmd16 = UI::Command.new("Weld Objects (Rick Wilson)") { join_edges }
cmd16.small_icon = "CD_ICONS/POWER/weld_16.png"
cmd16.large_icon = "CD_ICONS/POWER/weld_24.png"
cmd16.tooltip = "Joins Edges and Curves"
gp_cd_power_m_tb.add_item(cmd16)
_cd_power_m_plugins_menu.add_item("Weld Objects (Rick Wilson)") { join_edges }

################################################################################################## 

Sketchup.require 'protrude/protrude.rbs'
cmd16 = UI::Command.new("Protrude Dialog (Jim Foltz)") { ProtrudeDialog.toggle }
cmd16.small_icon = "CD_ICONS/POWER/protrude_16.png"
cmd16.large_icon = "CD_ICONS/POWER/protrude_24.png"
cmd16.tooltip = "Protrude Dialog (Jim Foltz)"
gp_cd_power_m_tb.add_item(cmd16)
_cd_power_m_plugins_menu.add_item("Protrude Dialog (Jim Foltz)") { ProtrudeDialog.toggle }

################################################################################################## 
gp_cd_power_m_tb.add_separator
################################################################################################## 

cmd31 = UI::Command.new("3x3 FFD (Chris Phillips) (SAVE BEFORE USE)"){startFFD(Sketchup.active_model.selection[0],[3,3,3],"false")}
cmd31.small_icon = "CD_ICONS/POWER/ffd3x3_16.png"
cmd31.large_icon = "CD_ICONS/POWER/ffd3x3_24.png"
cmd31.tooltip = "Freeform Deformation - 3x3 Grid"
gp_cd_power_m_tb.add_item(cmd31)
_freeform_menu.add_item("3x3 FFD (Chris Phillips) (SAVE BEFORE USE)"){startFFD(Sketchup.active_model.selection[0],[3,3,3],"false")}

################################################################################################## 

cmd32 = UI::Command.new("NxN FFD (Chris Phillips) (SAVE BEFORE USE)"){
prompts = ["Width","Depth","Height","Subdivide"]
values = [4, 4, 4,"false"]
results = inputbox prompts, values,["","","","true|false"], "FFD Dimensions"
if (results)
startFFD(Sketchup.active_model.selection[0],results,results[3]) 
end
}
#end
cmd32.small_icon = "CD_ICONS/POWER/ffdnxn_16.png"
cmd32.large_icon = "CD_ICONS/POWER/ffdnxn_24.png"
cmd32.tooltip = "Freeform Deformation - NxN Grid"
gp_cd_power_m_tb.add_item(cmd32)
_freeform_menu.add_item("NxN FFD (Chris Phillips) (SAVE BEFORE USE)"){
prompts = ["Width","Depth","Height","Subdivide"]
values = [4, 4, 4,"false"]
results = inputbox prompts, values,["","","","true|false"], "FFD Dimensions"
if (results)
startFFD(Sketchup.active_model.selection[0],results,results[3]) 
end
}
#end

################################################################################################## 

cmd33 = UI::Command.new("Lock edges (Chris Phillips) "){
Sketchup.active_model.start_operation "Lock Edges"
Sketchup.active_model.selection.each{|ent|
if(ent.class==Sketchup::Edge)
ent.vertices.each{|v| v.set_attribute("SFFD","locked",true)}
end
}
Sketchup.active_model.commit_operation
}    
cmd33.small_icon = "CD_ICONS/POWER/ffdlockedges_16.png"
cmd33.large_icon = "CD_ICONS/POWER/ffdlockedges_24.png"
cmd33.tooltip = "Freeform Deformation - Lock Edges"
gp_cd_power_m_tb.add_item(cmd33)
_freeform_menu.add_item("Lock edges (Chris Phillips)"){
Sketchup.active_model.start_operation "Lock Edges"
Sketchup.active_model.selection.each{|ent|
if(ent.class==Sketchup::Edge)
ent.vertices.each{|v| v.set_attribute("SFFD","locked",true)}
end
}
Sketchup.active_model.commit_operation
}

################################################################################################## 

cmd34 = UI::Command.new("Unlock Edges (Chris Phillips)"){
Sketchup.active_model.start_operation "Unlock edges"
Sketchup.active_model.selection.each{|ent|
if(ent.class==Sketchup::Edge)
ent.vertices.each{|v| v.set_attribute("SFFD","locked",false)}
end
}
Sketchup.active_model.commit_operation
}		
cmd34.small_icon = "CD_ICONS/POWER/ffdunlockedges_16.png"
cmd34.large_icon = "CD_ICONS/POWER/ffdunlockedges_24.png"
cmd34.tooltip = "Freeform Deformation - Unlock edges"
gp_cd_power_m_tb.add_item(cmd34)
_freeform_menu.add_item("Unlock edges (Chris Phillips)"){
Sketchup.active_model.start_operation "Unlock Edges"
Sketchup.active_model.selection.each{|ent|
if(ent.class==Sketchup::Edge)
ent.vertices.each{|v| v.set_attribute("SFFD","locked",false)}
end
}
Sketchup.active_model.commit_operation
}
  
################################################################################################## 
gp_cd_power_m_tb.add_separator
################################################################################################## 
  
cmd24 = UI::Command.new("Component Spray Tool (Didier Bur)") { componentbrushtool }
cmd24.small_icon = "CD_ICONS/POWER/compospray_16.png"
cmd24.large_icon = "CD_ICONS/POWER/compospray_24.png"
cmd24.tooltip = "Paintbrush for Components"
gp_cd_power_m_tb.add_item(cmd24)
_utilities_menu.add_item("CompoSpray Tool (Didier Bur)") { componentbrushtool }
  
################################################################################################## 
    
cmd25 = UI::Command.new("Set default settings (Didier Bur)") { cbt_dialog_set_defaults }
cmd25.small_icon = "CD_ICONS/POWER/composprayset_16.png"
cmd25.large_icon = "CD_ICONS/POWER/composprayset_24.png"
cmd25.tooltip = "Paintbrush for Components Settings"
gp_cd_power_m_tb.add_item(cmd25)
_utilities_menu.add_item("CompoSpray Settings (Didier Bur)") { cbt_dialog_set_defaults }
		
################################################################################################## 		
gp_cd_power_m_tb.add_separator
################################################################################################## 		

cmd26 = UI::Command.new("Balustrades (Didier Bur -Thomas Marek)") { lines2balustrade }
cmd26.small_icon = "CD_ICONS/POWER/balustrade_16.png"
cmd26.large_icon = "CD_ICONS/POWER/balustrade_24.png"
cmd26.tooltip = "Creates Balustrades Along a Path (Also Comps)"
gp_cd_power_m_tb.add_item(cmd26)
_utilities_menu.add_item("Balustrades (Didier Bur - Thomas Marek)") { lines2balustrade }
		
################################################################################################## 		
		
		

file_loaded("cd_power_extension_m.rb")